import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Textsuche extends JFrame {
	
	private JPanel p1, p2;
	private JTextArea ta;
	private JLabel t;
	private JTextField eingabe;
	private JButton suche;
	private JComboBox algorithmus;
	
	
	public Textsuche() {
		super("Textsuche");
		this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
		
		Container framec = getContentPane();
		framec.setLayout(new BorderLayout());
		
		// Erzeugung und Layout des Fensters
        p1 = new JPanel();
        p2 = new JPanel();
        p1.setLayout(new BorderLayout());
        p2.setLayout(new GridLayout(1,4));
		
	 	ta = new JTextArea();
	 	ta.setLineWrap(true);
	 	t = new JLabel("Suchen nach:   ");
	 	t.setHorizontalAlignment(JLabel.RIGHT);
	 	eingabe = new JTextField();
	 	String[] s = {"Boyer-Moore", "Knuth-Morris-Pratt"};
	 	algorithmus = new JComboBox(s);
	 	
	 	suche = new JButton("Suche");
	 	suche.addActionListener(new ActionListener() {
	 		public void actionPerformed(ActionEvent e) {
	 			String s = eingabe.getText();
	 			String text = ta.getText();
	 			int i = -1;
	 			// Aufrufen des Boyer-Moore-Algorithmus
	 			if (!(s.equals(""))) {
	 				if (algorithmus.getSelectedIndex() == 0) {
	 					// Prfen, ob Boyer-Moore-Alg. ausgewhlt wurde
	 					i = boyermoore(text, s);
	 				}
	 				else {
	 					// sonst starte den KMP
	 					i = kmp(text, s);
	 				}
	 				if (i >= 0) {
			 			// Wenn Zeichenkette gefunden, dann im Text markieren
	 					ta.select(i, i + s.length());
	 				}
	 				else {
			 			// nicht gefunden, Warndialog einblenden
	 					JOptionPane.showMessageDialog(null,"String nicht gefunden!", "",JOptionPane.WARNING_MESSAGE);
		 			}
		 		}
		 		// Focus auf TextArea setzen, damit Markierung sichtbar wird
				ta.requestFocus();
	 		}
	 	});
	 	
        // Komponenten den Panels hinzufuegen                
        p1.add(ta, BorderLayout.CENTER);
        p2.add(algorithmus);
        p2.add(t);
        p2.add(eingabe);
        p2.add(suche);
        
        // Panels dem Fenster hinzufuegen
        framec.add(p1, BorderLayout.CENTER);
        framec.add(p2, BorderLayout.SOUTH);
        this.setSize(new Dimension(500, 300));
        this.setVisible(true);
	}

	
	/** Methode, welche den Knuth-Morris-Pratt-Algorithmus implementiert.
	  * @return Anfangsposition des gefunden Strings, -1 wenn nicht gefunden
	  * @ param text: der zu durchsuchende Text
	  * @ param s: String der in text zu suchen ist
	  */
	public int kmp(String text, String s) {
		// *** zu implementieren ***
	}
	
	/** Methode, welche den Boyer-Moore-Algorithmus implementiert.
	  * @return Anfangsposition des gefunden Strings, -1 wenn nicht gefunden
	  * @ param text: der zu durchsuchende Text
	  * @ param s: String der in text zu suchen ist
	  */
	public int boyermoore(String text, String s) {
		// *** zu implementieren ***
	}
	
	public static void main(String args[]) {
		
		Textsuche fenster = new Textsuche();
		fenster.show();
	}
}
